#!/bin/sh
# Configuration script
-# Copyright (C) 1988, 1990, 1991 Free Software Foundation, Inc.
+# Copyright (C) 1988, 1990, 1991, 1992 Free Software Foundation, Inc.
#This file is part of GNU.
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
-# $Id$
-
# Please email any bugs, comments, and/or additions to this file to:
Makefile=Makefile
Makefile_in=Makefile.in
-ansi=
arguments=$*
commontargets=
configdirs=
fatal=
floating_point=default
gas=default
+host_makefile_frag=
hosts=
-#hostsubdir=
-#namesubdir=
-next_prefix=
next_host=
-#next_namesubdir=
-#next_objdir=
+next_prefix=
next_site=
next_srcdir=
next_target=
next_tmpdir=
norecursion=
-#objdir=
-#objdiroption=
prefix=/usr/local
progname=
recurring=
removing=
+site_makefile_frag=
srcdir=
srctrigger=
target=
+target_makefile_frag=
targets=
-#targetsubdir=
undefinedargs=
verbose=
+version="$Revision$"
x11=default
-# or maybe grab from gcc/version.c
-version_path=
-next_version_path=
-
NO_EDIT="This file was generated automatically by configure. Do not edit."
## this is a little touchy and won't always work, but...
PWD=`pwd`
-if (echo $0 | grep '^/' > /dev/null) ; then
+if echo $0 | grep '^/' > /dev/null ; then
progname=$0
-elif (echo $0 | grep '/' > /dev/null) ; then
+elif echo $0 | grep '/' > /dev/null ; then
progname=${PWD}/$0
else
progname=$0
PATH=$PATH:${PWD} ; export PATH
fi
-configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
-
-if ${configsub} none >/dev/null 2>&1 ; then
- true
-else
- echo '***' cannot find config.sub.
- echo 1
-fi
-
for arg in $*;
do
# handle things that might have args following as separate words
if [ -n "${next_prefix}" ] ; then prefix=${arg} ; prefixoption="-prefix=${prefix}" ; next_prefix=
elif [ -n "${next_datadir}" ] ; then datadir=${arg} ; datadiroption="-datadir=${datadir}" ; next_datadir=
-# elif [ -n "${next_namesubdir}" ] ; then \
-# namesubdir=${arg} ; namesubdiroption="--namesubdir=${namesubdir}" ; next_namesubdir=
-# elif [ -n "${next_objdir}" ] ; then objdir=${arg} ; objdiroption="--objdir=${objdir}" ; next_objdir=
- elif [ -n "${next_version_path}" ] ; then version_path=${arg} ; next_version_path=
elif [ -n "${next_site}" ] ; then site=${arg} ; next_site=
elif [ -n "${next_srcdir}" ] ; then srcdir=${arg} ; next_srcdir=
elif [ -n "${next_target}" ] ; then
next_target=
- if [ -z "${targets}" ] ; then
+ case "${targets}" in
+ "")
newtargets="${targets} ${arg}"
targets="${newtargets}"
- else
+ ;;
+ *)
echo '***' Can only configure for one target at a time.
fatal=yes
- fi
+ ;;
+ esac
elif [ -n "${next_tmpdir}" ] ; then
next_tmpdir=
tmpdiroption="--tmpdir=${arg}"
else
case ${arg} in
- -ansi | --a*)
- ansi=true
- clib=clib
- ;;
-datadir=* | --datadir=* | --datadi=* | --datad=* | --data=* | --dat=* | --da=* | --d=*)
- datadir=`echo ${arg} | sed 's/-\{1,2\}d[a-z]*=//'`
+ datadir=`echo ${arg} | sed 's/^[-a-z]*=//'`
datadiroption=${arg}
;;
-datadir | --datadir | --datadi | --datad | --data | --dat | --da | --d)
fatal=true
;;
-host=* | --host=* | --hos=* | --ho=*)
-# if [ -n "${hosts}" ] ; then
-# subdirs="--subdirs"
-# fi
-
- if [ -z "${hosts}" ] ; then
- newhosts="${hosts} `echo ${arg} | sed 's/-\{1,2\}h[a-z]*=//'`"
+ case "${hosts}" in
+ "")
+ newhosts="${hosts} `echo ${arg} | sed 's/^[-a-z]*=//'`"
hosts="${newhosts}"
- else
+ ;;
+ *)
echo '***' Can only configure for one host at a time.
fatal=yes
- fi
+ ;;
+ esac
;;
- -languages=* | --languages=* | --language=* | --languag=* \
- | --langua=* | --langu=* | --lang=* | --lan=* | --la=* \
- | --l=*)
- languages="${languages} `echo ${arg} | sed 's/-\{1,2\}l[a-z]*=//'`"
- ;;
-# -namesubdir | --namesubdir | --namesubdi | --namesubd | --namesub | --namesu | --names | --name | --nam | --na)
-# next_namesubdir=yes
-# ;;
-# -namesubdir=* | --namesubdir=* | --namesubdi=* | --namesubd=* | --namesub=* | --namesu=* | --names=* | --name=* | --nam=* | --na=*)
-# namesubdir=`echo ${arg} | sed 's/-\{1,2\}na[a-z]*=//'`
-# namesubdiroption=${arg}
-# ;;
-nfp | --nf*)
floating_point=no
;;
-norecursion | --no*)
norecursion=true
;;
-# -objdir=* | --objdir=* | --objdi=* | --objd=* | --obj=* | --ob=* | --o=*)
-# objdiroption=${arg}
-# objdir=`echo ${arg} | sed 's/-\{1,2\}o[a-z]*=//'`
-# ;;
-# -objdir | --objdir | --objdi | --objd | --obj | --ob | --o)
-# next_objdir=yes
-# ;;
-prefix=* | --prefix=* | --prefi=* | --pref=* | --pre=* | --pr=* | --p=*)
- prefix=`echo ${arg} | sed 's/-\{1,2\}p[a-z]*=//'`
+ prefix=`echo ${arg} | sed 's/^[-a-z]*=//'`
prefixoption=${arg}
;;
-prefix | --prefix | --prefi | --pref | --pre | --pr | --p)
removing=${arg}
;;
-site=* | --site=* | --sit=* | --si=*)
- site=`echo ${arg} | sed 's/-\{1,2\}s[a-z]*=//'`
+ site=`echo ${arg} | sed 's/^[-a-z]*=//'`
;;
-site | --site | --sit | --si)
next_site=yes
;;
-srcdir=* | --srcdir=* | --srcdi=* | --srcd=* | --src=* | --sr=*)
- srcdir=`echo ${arg} | sed 's/-\{1,2\}s[a-z]*=//'`
+ srcdir=`echo ${arg} | sed 's/^[-a-z]*=//'`
;;
-srcdir | --srcdir | --srcdi | --srcd | --src | --sr)
next_srcdir=yes
;;
-# -subdirs | --su*)
-# subdirs=${arg}
-# ;;
-target=* | --target=* | --targe=* | --targ=* | --tar=* | --ta=*)
-# if [ -n "${targets}" ] ; then
-# subdirs="--subdirs"
-# fi
-
- if [ -z "${targets}" ] ; then
- newtargets="${targets} `echo ${arg} | sed 's/-\{1,2\}t[a-z]*=//'`"
+ case "${targets}" in
+ "")
+ newtargets="${targets} `echo ${arg} | sed 's/^[-a-z]*=//'`"
targets="${newtargets}"
- else
+ ;;
+ *)
echo '***' Can only configure for one target at a time.
fatal=yes
- fi
+ ;;
+ esac
;;
-target | --target | --targe | --targ | --tar | --ta)
next_target=yes
;;
-tmpdir=* | --tmpdir=* | --tmpdi=* | --tmpd=* | --tmp=* | --tm=*)
tmpdiroption=${arg}
- TMPDIR=`echo ${arg} | sed 's/-\{1,2\}t[a-z]*=//'`
+ TMPDIR=`echo ${arg} | sed 's/^[-a-z]*=//'`
;;
-tmpdir | --tmpdir | --tmpdi | --tmpd | --tmp | --tm)
next_tmpdir=yes
-v | -verbose | --v)
verbose=${arg}
;;
+ -version | -V | --version | --V)
+ echo "This is Cygnus Configure version" `echo ${version} | sed 's/[ $:]//g'`
+ exit 0
+ ;;
-x | --x) ;;
-* | --*)
(echo ;
fatal=true
;;
*)
-# if [ -n "${hosts}" ] ; then
-# subdirs="--subdirs"
-# fi
-
- if [ -z "${undefs}" ] ; then
+ case "${undefs}" in
+ "")
newundefs="${undefs} ${arg}"
undefs=${newundefs}
- else
+ ;;
+ *)
echo '***' Can only configure for one host and one target at a time.
fatal=yes
- fi
+ ;;
+ esac
;;
esac
fi
done
-if [ -n "${verbose}" ] ; then
- echo $0 $*
-fi
-
# process host and target
-if [ -z "${fatal}" ] ; then
+case "${fatal}" in
+"")
# # Complain if an arg is missing
# if [ -z "${hosts}" ] ; then
# (echo ;
echo '***' You must tell me for which host you want to configure.
fatal=yes
else
- if [ -z "${hosts}" ] ; then
- hosts=${undefs}
- fi
+ case "${hosts}" in
+ "") hosts=${undefs} ;;
+ *) ;;
+ esac
- if [ -z "${targets}" ] ; then
- if [ -n "${undefs}" ] ; then
- targets=${undefs}
- else
- targets=${hosts}
- fi
- fi
+ case "${targets}" in
+ "")
+ case "${undefs}" in
+ "") targets=${hosts} ;;
+ *) targets=${undefs} ;;
+ esac
+ ;;
+ *) ;;
+ esac
fi
-fi
+ ;;
+*) ;;
+esac
if [ -n "${fatal}" -o "${hosts}" = "help" ] ; then
(echo "Usage: configure HOST" ;
echo ;
echo "Options: [defaults in brackets]" ;
- echo " -ansi configure w/ANSI library. [no ansi lib]" ;
echo " -datadir=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
echo " -gas configure the compilers for use with gas. [native as]" ;
echo " -help print this message. [normal config]" ;
echo " -lang=LANG configure to build LANG. [gcc]" ;
echo " -nfp configure the compilers default to soft floating point. [hard float]" ;
echo " -norecursion configure this directory only. [recurse]" ;
-# echo " -objdir=ODIR configure in a parallel tree rooted in ODIR. [rooted in \".\"]" ;
echo " -prefix=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
echo " -rm remove this configuration. [build a configuration]" ;
echo " -site configure with site specific makefile" ;
echo " -srcdir=DIR find the sources in DIR. [\".\" or \"..\"]" ;
-# This is correctly aligned in the output, even though it isn't here.
-# echo " -subdirs configure in subdirectories. [in source directories]" ;
echo " -target=TARGET configure for TARGET. [TARGET = HOST]" ;
echo " -tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
echo ;
echo "Where HOST and TARGET are something like \"vax\", \"sun3\", \"encore\", etc." ;
-# echo "Asking for more than one \"--target\" implies \"--subdirs\". Any other" ;
-# echo "options given will apply to all targets."
) 1>&2
if [ -r config.status ] ; then
exit 1
fi
-if [ -z "${srcdir}" ] ; then
+configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
+
+if ${configsub} `echo ${hosts} | sed -e 's/ .*//'` >/dev/null 2>&1 ; then
+ true
+else
+ echo '***' cannot find config.sub.
+ exit 1
+fi
+
+case "${srcdir}" in
+"")
if [ -r configure.in ] ; then
srcdir=.
- elif [ -r ../configure.in ] ; then
- srcdir=..
else
echo '***' "Can't find configure.in. Try using -srcdir=some_dir"
exit 1
fi
-fi
+ ;;
+*) ;;
+esac
+# default datadir
+case "${datadir}" in
+"") datadir="$(prefix)/lib" ;;
+*) ;;
+esac
+
### break up ${srcdir}/configure.in.
-if [ -z "`grep '^# per\-host:' ${srcdir}/configure.in`" ] ; then
+case "`grep '^# per\-host:' ${srcdir}/configure.in`" in
+"")
echo '***' ${srcdir}/configure.in has no "per-host:" line. 1>&2
exit 1
-fi
+ ;;
+*) ;;
+esac
-if [ -z "`grep '^# per\-target:' ${srcdir}/configure.in`" ] ; then
+case "`grep '^# per\-target:' ${srcdir}/configure.in`" in
+"")
echo '***' ${srcdir}/configure.in has no "per-target:" line. 1>&2
exit 1
-fi
+ ;;
+*) ;;
+esac
-if [ -z "${TMPDIR}" ] ; then
- TMPDIR=/tmp ; export TMPDIR
-fi
+case "${TMPDIR}" in
+"") TMPDIR=/tmp ; export TMPDIR ;;
+*) ;;
+esac
# keep this filename short for &%*%$*# 14 char file names
tmpfile=${TMPDIR}/cONf$$
. ${tmpfile}.com
# some sanity checks on configure.in
-if [ -z "${srctrigger}" ] ; then
+case "${srctrigger}" in
+"")
echo '***' srctrigger not set in ${PWD}/configure.in.
exit 1
-fi
+ ;;
+*) ;;
+esac
for host in ${hosts} ; do
# Default other arg
host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
host=${host_cpu}-${host_vendor}-${host_os}
- host_makefile_frag=config/mh-${host}
- if [ ! -f ${host_makefile_frag} ]
- then
- host_makefile_frag=config/mh-${host_alias}
- fi
. ${tmpfile}.hst
target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
target=${target_cpu}-${target_vendor}-${target_os}
- target_makefile_frag=config/mt-${target}
- if [ ! -f ${target_makefile_frag} ]
- then
- target_makefile_frag=config/mt-${target_alias}
- fi
. ${tmpfile}.tgt
- if [ "${host_alias}" = "${target_alias}" ] ; then
- subdirname=H-${host_alias}
- else
- subdirname=X-${host_alias}-${target_alias}
- fi
-
- if [ -n "${namesubdir}" ] ; then
- subdirname=${namesubdir}
- fi
+ case "${host_alias}" in
+ "${target_alias}") subdirname=H-${host_alias} ;;
+ *) subdirname=X-${host_alias}-${target_alias} ;;
+ esac
- if [ -n "${removing}" ] ; then
-# if [ -n "${objdir}" ] ; then
-# echo '***' --rm not supported for --objdir. Just \"rm -rf ${objdir}\" by hand.
-# exit 1
-# fi
-
-# if [ -n "${subdirs}" ] ; then
-# if [ -d "${subdirname}" ] ; then
-# rm -rf ${hostsubdir}
-# else
-# echo Warning: no ${PWD}/${hostsubdir} to remove.
-# fi
-# else
- rm -f ${Makefile} config.status ${links}
-# fi
- else
-# if [ -n "${objdir}" ]; then
-# srcdir=${PWD}
-# cd ${objdir}
-# fi
-
-# if [ -n "${subdirs}" ] ; then
-# # check for existing status before allowing forced subdirs.
-# if [ -f ${Makefile} ] ; then
-# echo '***' "${Makefile} already exists in source directory. ${PWD} not configured." 1>&2
-# exit 1
-# fi
-#
-# # use a subdir common to all targets for this host iff: this is a cross AND
-# # this tool does not claim to be target dependent AND we have not been asked to name the subdir.
-# if [ ${host_alias} != ${target_alias} -a -z "${target_dependent}" -a -z "${namesubdiroption}" ]
-# then
-# if [ ! -d H-${host_alias} ] ; then mkdir H-${host_alias} ; fi
-#
-# if (${symbolic_link} ${subdirname} H-${host_alias} 2> /dev/null) ; then
-# true
-# else # just give up. they lose.
-# rmdir H-${host_alias}
-# if [ ! -d ${subdirname} ] ; then mkdir ${subdirname} ; fi
-# fi
-# elif [ ! -d ${subdirname} ] ; then
-# mkdir ${subdirname}
-# fi
-#
-# cd ${subdirname}
-#
-# if [ -z "${srcdir}" ] ; then
-# srcdir=..
-# fi
-# elif [ "`echo H-*`" != "H-*" -a "`echo X-*`" != "X-*" ] ; then
-# # if not subdir builds, then make sure none exist.
-# # We might miss if there are explicitly named subdirs.
-# echo '***' "Configured subdirs exist. ${PWD} not configured." 1>&2
-# exit 1
-# else
-# true
-# fi
+ case "${namesubdir}" in
+ "") ;;
+ *) subdirname=${namesubdir} ;;
+ esac
+ case "${removing}" in
+ "")
# Find the source files, if location was not specified.
- if [ -z "${srcdir}" ] ; then
+ case "${srcdir}" in
+ "")
srcdirdefaulted=1
srcdir=.
if [ ! -r ${srctrigger} ] ; then
srcdir=..
fi
- fi
+ ;;
+ *) ;;
+ esac
if [ ! -r ${srcdir}/${srctrigger} ] ; then
- if [ -z "${srcdirdefaulted}" ] ; then
- echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/${srcdir}" 1>&2
- else
- echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/. or ${PWD}/.." 1>&2
- fi
+ case "${srcdirdefaulted}" in
+ "") echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/${srcdir}" 1>&2 ;;
+ *) echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/. or ${PWD}/.." 1>&2 ;;
+ esac
echo '***' \(At least ${srctrigger} is missing.\) 1>&2
exit 1
exit 1
fi
- if [ -n "${verbose}" ] ; then
- echo "Linked \"${link}\" to \"${srcdir}/${file}\"."
- fi
+ case "${verbose}" in
+ "") ;;
+ *) echo "Linked \"${link}\" to \"${srcdir}/${file}\"." ;;
+ esac
done
# Create a .gdbinit file which runs the one in srcdir
case ${srcdir} in
.)
;;
- *)
- echo "# "${NO_EDIT} > .gdbinit
- echo "dir ." >> .gdbinit
- echo "dir ${srcdir}" >> .gdbinit
- echo "source ${srcdir}/.gdbinit" >> .gdbinit
+ *) cat > .gdbinit <<EOF
+# ${NO_EDIT} > .gdbinit
+dir .
+dir ${srcdir}
+source ${srcdir}/.gdbinit
+EOF
;;
esac
fi
# Install a makefile, and make it set VPATH
# if necessary so that the sources are found.
# Also change its value of srcdir.
+ # NOTE: Makefile generation constitutes the majority of the time in configure. Hence, this section has
+ # been somewhat optimized and is perhaps a bit twisty.
- # FIXME-someday: This business of always writing to .tem and mv back
- # is so that I don't screw things up while developing. Once this
- # template is stable, these should be optimized. xoxorich.
+ # code is order so as to try to sed the smallest input files we know.
- # Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
- if [ "${host}" != "${target}" ] ; then
- echo "CROSS=-DCROSS_COMPILE" > ${Makefile}
- echo "ALL=start.encap" >> ${Makefile}
- else
- echo "ALL=all.internal" > ${Makefile}
- fi
+ # the three makefile fragments MUST end up in the resulting Makefile in this order: target, host, and site.
+ # so do these separately because I don't trust the order of sed -e expressions.
+
+ # Conditionalize for this site from "Makefile.in" (or whatever it's called) into Makefile.tem
+ case "${site}" in
+ "") cp ${srcdir}/${Makefile_in} Makefile.tem ;;
+ *)
+ site_makefile_frag=${srcdir}/config/ms-${site}
- # set target, host, VPATH
- echo "host_alias = ${host_alias}" >> ${Makefile}
- echo "host_cpu = ${host_cpu}" >> ${Makefile}
- echo "host_vendor = ${host_vendor}" >> ${Makefile}
- echo "host_os = ${host_os}" >> ${Makefile}
- echo "version_path = ${version_path}" >> ${Makefile}
- echo "target_alias = ${target_alias}" >> ${Makefile}
- echo "target_cpu = ${target_cpu}" >> ${Makefile}
- echo "target_vendor = ${target_vendor}" >> ${Makefile}
- echo "target_os = ${target_os}" >> ${Makefile}
-
-# if [ -n "${subdirs}" ] ; then
-# (echo "subdir = /${subdirname}" ;
-# echo "unsubdir = ..") >> ${Makefile}
-# else
- (echo "subdir =" ;
- echo "unsubdir = .") >> ${Makefile}
-# fi
-
- # echo "workdir = ${PWD}" >> ${Makefile}
- echo "VPATH = ${srcdir}" >> ${Makefile}
-
- # add "Makefile.in" (or whatever it's called)
- cat ${srcdir}/${Makefile_in} >> ${Makefile}
-
- # Conditionalize the makefile for this site.
- if [ -n "${site}" ] ; then
- site_makefile_frag=config/ms-${site}
-
- if [ -f ${srcdir}/${site_makefile_frag} ] ; then
- (echo "site_makefile_frag = ${srcdir}/${site_makefile_frag}" ;
- sed -e "/^####/ r ${srcdir}/${site_makefile_frag}" ${Makefile}) > Makefile.tem
+ if [ -f ${site_makefile_frag} ] ; then
+ sed -e "/^####/ r ${site_makefile_frag}" ${srcdir}/${Makefile_in} \
+ >> Makefile.tem
else
- (echo "site_makefile_frag =" ;
- cat ${Makefile}) > Makefile.tem
+ cp ${srcdir}/${Makefile_in} Makefile.tem
+ site_makefile_frag=
fi
- mv Makefile.tem ${Makefile}
- fi
+ ;;
+ esac
+ # working copy now in Makefile.tem
# Conditionalize the makefile for this host.
- if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- (echo "host_makefile_frag = ${srcdir}/${host_makefile_frag}" ;
- sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" ${Makefile}) > Makefile.tem
- else
- (echo "host_makefile_frag =" ;
- cat ${Makefile}) > Makefile.tem
- fi
- mv Makefile.tem ${Makefile}
+ case "${host_makefile_frag}" in
+ "") mv Makefile.tem ${Makefile} ;;
+ *)
+ host_makefile_frag=${srcdir}/${host_makefile_frag}
+ if [ -f ${host_makefile_frag} ] ; then
+ sed -e "/^####/ r ${host_makefile_frag}" Makefile.tem > ${Makefile}
+ else
+ echo '***' Expected host makefile fragment \"${host_makefile_frag}\" 1>&2
+ echo '***' is missing in ${PWD}. 1>&2
+ mv Makefile.tem ${Makefile}
+ fi
+ esac
+ # working copy now in ${Makefile}
# Conditionalize the makefile for this target.
- if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- (echo "target_makefile_frag = ${srcdir}/${target_makefile_frag}" ;
- sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" ${Makefile}) > Makefile.tem
- else
- (echo "target_makefile_frag =" ;
- cat ${Makefile}) > Makefile.tem
- fi
- mv Makefile.tem ${Makefile}
-
- # set srcdir
- sed "s@^srcdir = \.@srcdir = ${srcdir}@" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
-
- # set prefix
- if [ -n "${prefix}" ] ; then
- sed "s:^prefix =.*$:prefix = ${prefix}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
- fi
-
- # set datadir
- if [ -n "${datadir}" ] ; then
- sed "s:^datadir =.*$:datadir = ${datadir}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
- fi
-
- # reset SUBDIRS
- sed "s:^SUBDIRS =.*$:SUBDIRS = ${configdirs}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
+ case "${target_makefile_frag}" in
+ "") mv ${Makefile} Makefile.tem ;;
+ *)
+ target_makefile_frag=${srcdir}/${target_makefile_frag}
+ if [ -f ${target_makefile_frag} ] ; then
+ sed -e "/^####/ r ${target_makefile_frag}" ${Makefile} >> Makefile.tem
+ else
+ mv ${Makefile} Makefile.tem
+ target_makefile_frag=
+ fi
+ ;;
+ esac
+ # real copy now in Makefile.tem
- # reset NONSUBDIRS
- sed "s:^NONSUBDIRS =.*$:NONSUBDIRS = ${noconfigdirs}:" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
+ # prepend warning about editting, and a bunch of variables.
+ # fixme-someday: remove the subdir/unsubdir lines.
+ cat > ${Makefile} <<EOF
+# ${NO_EDIT}
+host_alias = ${host_alias}
+host_cpu = ${host_cpu}
+host_vendor = ${host_vendor}
+host_os = ${host_os}
+target_alias = ${target_alias}
+target_cpu = ${target_cpu}
+target_vendor = ${target_vendor}
+target_os = ${target_os}
+target_makefile_frag = ${target_makefile_frag}
+host_makefile_frag = ${host_makefile_frag}
+site_makefile_frag = ${site_makefile_frag}
+VPATH = ${srcdir}
+subdir =
+unsubdir = .
+EOF
+
+ # fixme: this shouldn't be in configure.
+ # Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
+ case "${host}" in
+ "${target}") echo "ALL=all.internal" >> ${Makefile} ;;
+ *)
+ echo "CROSS=-DCROSS_COMPILE" >> ${Makefile}
+ echo "ALL=all.cross" >> ${Makefile}
+ ;;
+ esac
+
+ # reset prefix, datadir, srcdir, SUBDIRS, NONSUBDIRS, remove any form
+ # feeds.
+ sed -e "s:^prefix[ ]*=.*$:prefix = ${prefix}:" \
+ -e "s:^datadir[ ]*=.*$:datadir = ${datadir}:" \
+ -e "s:^srcdir[ ]*=.*$:srcdir = ${srcdir}:" \
+ -e "s:^SUBDIRS[ ]*=.*$:SUBDIRS = ${configdirs}:" \
+ -e "s:^NONSUBDIRS[ ]*=.*$:NONSUBDIRS = ${noconfigdirs}:" \
+ -e "s/\f//" Makefile.tem >> ${Makefile}
+ # final copy now in ${Makefile}
+
+ rm Makefile.tem
- # remove any form feeds.
- sed -e "s/\f//" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
+ if [ -n "${verbose}" -o -z "${recurring}" ] ; then
+ case "${host_makefile_frag}" in
+ "") using= ;;
+ *) using="and \"${host_makefile_frag}\"" ;;
+ esac
- # prepend warning about editting.
- echo "# "${NO_EDIT} > ${Makefile}.tem
- cat ${Makefile} >> ${Makefile}.tem
- mv Makefile.tem ${Makefile}
+ case "${target_makefile_frag}" in
+ "") ;;
+ *) using="${using} and \"${target_makefile_frag}\"" ;;
+ esac
- using=
- if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- using="${using} and \"${host_makefile_frag}\""
- fi
- if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- using="${using} and \"${target_makefile_frag}\""
- fi
- if [ -n "${site}" -a \
- -f ${srcdir}/${site_makefile_frag} ] ; then
- using="${using} and \"${site_makefile_frag}\""
- fi
- using=`echo "${using}" | sed 's/and/using/'`
- using="Created \"${Makefile}\" in ${PWD}${using}."
+ case "${site_makefile_frag}" in
+ "") ;;
+ *) using="${using} and \"${site_makefile_frag}\"" ;;
+ esac
- if [ -n "${verbose}" -o -z "${recurring}" ] ; then
- echo ${using}
+ echo "Created \"${Makefile}\" in" ${PWD} `echo "${using}" | sed 's/and/using/'`
fi
. ${tmpfile}.pos
# the same configuration. Used in Makefiles to rebuild
# Makefiles.
- if [ -z "${norecursion}" ] ; then
- arguments="${arguments} -norecursion"
- fi
+ case "${norecursion}" in
+ "") arguments="${arguments} -norecursion" ;;
+ *) ;;
+ esac
echo "#!/bin/sh
# ${NO_EDIT}
${progname}" ${arguments} "
# ${using}" > config.status
chmod a+x config.status
-
-# originaldir=${PWD}
-# cd ${srcdir}
- fi
+ ;;
+ *) rm -f ${Makefile} config.status ${links} ;;
+ esac
# If there are subdirectories, then recur.
if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
for configdir in ${configdirs} ; do
- if [ -n "${verbose}" ] ; then
- echo Configuring ${configdir}...
- fi
+ case "${verbose}" in
+ "") ;;
+ *) echo Configuring ${configdir}... ;;
+ esac
if [ -d ${srcdir}/${configdir} ] ; then
- if [ "${srcdir}" != "." ] ; then
+ case "${srcdir}" in
+ ".") ;;
+ *)
if [ ! -d ./${configdir} ] ; then
mkdir ./${configdir}
fi
- fi
+ ;;
+ esac
POPDIR=${PWD}
cd ${configdir}
-### figure out what to do with srcdir
+### figure out what to do with srcdir & guest configure
case "${srcdir}" in
- ".") ;; # do nothing. We're building in place.
- "..") srcdiroption="-srcdir=../../${configdir}" ;;
- *) srcdiroption="-srcdir=${srcdir}/${configdir}" ;;
+ ".") newsrcdir=${srcdir} ;; # no -srcdir option. We're building in place.
+ /*) # absolute path
+ newsrcdir=${srcdir}/${configdir}
+ srcdiroption="-srcdir=${newsrcdir}"
+ ;;
+ *) # otherwise relative
+ newsrcdir=../${srcdir}/${configdir}
+ srcdiroption="-srcdir=${newsrcdir}"
+ ;;
esac
### The recursion line is here.
- if (${progname} -recurring ${host_alias} -target=${target_alias} \
+ if [ -f ${newsrcdir}/configure ] ; then
+ recprog=${newsrcdir}/configure
+ else
+ recprog=${progname}
+ fi
+
+ if ${recprog} -recurring ${host_alias} -target=${target_alias} \
${verbose} ${subdirs} ${removing} ${prefixoption} \
${tmpdiroption} ${namesubdiroption} ${datadiroption} \
- ${srcdiroption}) ; then
+ ${srcdiroption} ; then
true
else
exit 1
fi
cd ${POPDIR}
- elif [ -n "${verbose}" ] ; then
- echo Warning: source directory \"${srcdir}/${configdir}\" is missing.
+ else
+ case "${verbose}" in
+ "") ;;
+ *) echo Warning: source directory \"${srcdir}/${configdir}\" is missing. ;;
+ esac
fi
done
fi
done # for each target
-
- # Now build a Makefile for this host.
-# if [ -n "${subdirs}" -a ! -n "${removing}" ] ; then
-# push=${PWD}
-#
-# if [ -n "${objdir}" ] ; then
-# cd ${objdir}
-# fi
-#
-# cd ${hostsubdir}
-# cat > GNUmakefile << 'E!O!F'
-## Makefile generated by configure for host ${host_alias}.
-#
-#ALL := $(shell ls -d T-*)
-#
-#%:
-# $(foreach subdir,$(ALL),$(MAKE) -C $(subdir) \$@ &&) true
-#
-#all:
-#E!O!F
-# cd ${push}
-# fi
done # for each host
### clean up.